/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.252 Revision 1.337
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.252 2006/10/05 00:12:07 nyhm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.337 2010/03/02 00:52:26 reavertm Exp $
4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
4# 14#
5# This eclass is for general purpose functions that most ebuilds 15# Due to the nature of this eclass, some functions may have maintainers
6# have to implement themselves. 16# different from the overall eclass!
7#
8# NB: If you add anything, please comment it!
9#
10# Maintainer: see each individual function, base-system@gentoo.org as default
11 17
12inherit multilib portability 18inherit multilib portability
13 19
14DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
15 21
16# Wait for the supplied number of seconds. If no argument is supplied, defaults 22if has "${EAPI:-0}" 0 1 2; then
17# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 23
18# outputting to a terminal, don't wait. For compatability purposes, the argument 24# @FUNCTION: epause
19# must be an integer greater than zero. 25# @USAGE: [seconds]
20# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 26# @DESCRIPTION:
27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
28# printing a message the user should probably be reading and often used in
29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
30# don't wait at all. Defined in EAPIs 0 1 and 2.
21epause() { 31epause() {
22 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
23} 33}
24 34
25# Beep the specified number of times (defaults to five). If our output 35# @FUNCTION: ebeep
26# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 36# @USAGE: [number of beeps]
27# don't beep. 37# @DESCRIPTION:
28# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
29ebeep() { 42ebeep() {
30 local n 43 local n
31 if [[ -z ${EBEEP_IGNORE} ]] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
32 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
33 echo -ne "\a" 46 echo -ne "\a"
36 sleep 1 49 sleep 1
37 done 50 done
38 fi 51 fi
39} 52}
40 53
41# This function generate linker scripts in /usr/lib for dynamic 54else
42# libs in /lib. This is to fix linking problems when you have 55
43# the .so in /lib, and the .a in /usr/lib. What happens is that 56ebeep() {
44# in some cases when linking dynamic, the .a in /usr/lib is used 57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
45# instead of the .so in /lib due to gcc/libtool tweaking ld's 58}
46# library search path. This cause many builds to fail. 59
47# See bug #4411 for more info. 60epause() {
48# 61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
49# To use, simply call: 62}
50# 63
51# gen_usr_ldscript libfoo.so
52#
53# Note that you should in general use the unversioned name of
54# the library, as ldconfig should usually update it correctly
55# to point to the latest version of the library present.
56#
57# <azarah@gentoo.org> (26 Oct 2002)
58#
59gen_usr_ldscript() {
60 if [[ $(type -t _tc_gen_usr_ldscript) == "function" ]] ; then
61 _tc_gen_usr_ldscript "$@"
62 return $?
63 fi 64fi
64 65
65 ewarn "QA Notice: Please upgrade your ebuild to use toolchain-funcs" 66# @FUNCTION: ecvs_clean
66 ewarn "QA Notice: rather than gen_usr_ldscript() from eutils" 67# @USAGE: [list of dirs]
68# @DESCRIPTION:
69# Remove CVS directories recursiveley. Useful when a source tarball contains
70# internal CVS directories. Defaults to $PWD.
71ecvs_clean() {
72 [[ -z $* ]] && set -- .
73 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
74 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
75}
67 76
68 local lib libdir=$(get_libdir) 77# @FUNCTION: esvn_clean
69 # Just make sure it exists 78# @USAGE: [list of dirs]
70 dodir /usr/${libdir} 79# @DESCRIPTION:
80# Remove .svn directories recursiveley. Useful when a source tarball contains
81# internal Subversion directories. Defaults to $PWD.
82esvn_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
85}
71 86
72 for lib in "${@}" ; do 87# @FUNCTION: eshopts_push
73 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 88# @USAGE: [options to `set` or `shopt`]
74 /* GNU ld script 89# @DESCRIPTION:
75 Since Gentoo has critical dynamic libraries 90# Often times code will want to enable a shell option to change code behavior.
76 in /lib, and the static versions in /usr/lib, 91# Since changing shell options can easily break other pieces of code (which
77 we need to have a "fake" dynamic lib in /usr/lib, 92# assume the default state), eshopts_push is used to (1) push the current shell
78 otherwise we run into linking problems. 93# options onto a stack and (2) pass the specified arguments to set.
79 94#
80 See bug http://bugs.gentoo.org/4411 for more info. 95# If the first argument is '-s' or '-u', we assume you want to call `shopt`
81 */ 96# rather than `set` as there are some options only available via that.
82 GROUP ( /${libdir}/${lib} ) 97#
83 END_LDSCRIPT 98# A common example is to disable shell globbing so that special meaning/care
84 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 99# may be used with variables/arguments to custom functions. That would be:
100# @CODE
101# eshopts_push -o noglob
102# for x in ${foo} ; do
103# if ...some check... ; then
104# eshopts_pop
105# return 0
106# fi
85 done 107# done
108# eshopts_pop
109# @CODE
110eshopts_push() {
111 # have to assume __ESHOPTS_SAVE__ isn't screwed with
112 # as a `declare -a` here will reset its value
113 local i=${#__ESHOPTS_SAVE__[@]}
114 if [[ $1 == -[su] ]] ; then
115 __ESHOPTS_SAVE__[$i]=$(shopt -p)
116 [[ $# -eq 0 ]] && return 0
117 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
118 else
119 __ESHOPTS_SAVE__[$i]=$-
120 [[ $# -eq 0 ]] && return 0
121 set "$@" || die "eshopts_push: bad options to set: $*"
122 fi
86} 123}
87 124
125# @FUNCTION: eshopts_pop
126# @USAGE:
127# @DESCRIPTION:
128# Restore the shell options to the state saved with the corresponding
129# eshopts_push call. See that function for more details.
130eshopts_pop() {
131 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
132 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
133 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
134 local s=${__ESHOPTS_SAVE__[$i]}
135 unset __ESHOPTS_SAVE__[$i]
136 if [[ ${s} == "shopt -"* ]] ; then
137 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
138 else
139 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
140 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
141 fi
142}
88 143
89# Default directory where patches are located 144# @VARIABLE: EPATCH_SOURCE
145# @DESCRIPTION:
146# Default directory to search for patches.
90EPATCH_SOURCE="${WORKDIR}/patch" 147EPATCH_SOURCE="${WORKDIR}/patch"
91# Default extension for patches 148# @VARIABLE: EPATCH_SUFFIX
149# @DESCRIPTION:
150# Default extension for patches (do not prefix the period yourself).
92EPATCH_SUFFIX="patch.bz2" 151EPATCH_SUFFIX="patch.bz2"
152# @VARIABLE: EPATCH_OPTS
153# @DESCRIPTION:
93# Default options for patch 154# Default options for patch:
155# @CODE
94# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 156# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
95# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 157# --no-backup-if-mismatch - do not leave .orig files behind
96# Set -E to automatically remove empty files. 158# -E - automatically remove empty files
159# @CODE
97EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 160EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
161# @VARIABLE: EPATCH_EXCLUDE
162# @DESCRIPTION:
98# List of patches not to apply. Not this is only file names, 163# List of patches not to apply. Note this is only file names,
99# and not the full path .. 164# and not the full path. Globs accepted.
100EPATCH_EXCLUDE="" 165EPATCH_EXCLUDE=""
166# @VARIABLE: EPATCH_SINGLE_MSG
167# @DESCRIPTION:
101# Change the printed message for a single patch. 168# Change the printed message for a single patch.
102EPATCH_SINGLE_MSG="" 169EPATCH_SINGLE_MSG=""
170# @VARIABLE: EPATCH_MULTI_MSG
171# @DESCRIPTION:
103# Change the printed message for multiple patches. 172# Change the printed message for multiple patches.
104EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 173EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
105# Force applying bulk patches even if not following the style: 174# @VARIABLE: EPATCH_FORCE
106# 175# @DESCRIPTION:
107# ??_${ARCH}_foo.${EPATCH_SUFFIX} 176# Only require patches to match EPATCH_SUFFIX rather than the extended
108# 177# arch naming style.
109EPATCH_FORCE="no" 178EPATCH_FORCE="no"
110 179
111# This function is for bulk patching, or in theory for just one 180# @FUNCTION: epatch
112# or two patches. 181# @USAGE: [patches] [dirs of patches]
182# @DESCRIPTION:
183# epatch is designed to greatly simplify the application of patches. It can
184# process patch files directly, or directories of patches. The patches may be
185# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
186# the -p option as epatch will automatically attempt -p0 to -p5 until things
187# apply successfully.
113# 188#
114# It should work with .bz2, .gz, .zip and plain text patches. 189# If you do not specify any options, then epatch will default to the directory
115# Currently all patches should be the same format. 190# specified by EPATCH_SOURCE.
116# 191#
117# You do not have to specify '-p' option to patch, as it will 192# When processing directories, epatch will apply all patches that match:
118# try with -p0 to -p5 until it succeed, or fail at -p5. 193# @CODE
119# 194# ${EPATCH_FORCE} == "yes"
120# Above EPATCH_* variables can be used to control various defaults,
121# bug they should be left as is to ensure an ebuild can rely on
122# them for.
123#
124# Patches are applied in current directory.
125#
126# Bulk Patches should preferibly have the form of:
127#
128# ??_${ARCH}_foo.${EPATCH_SUFFIX} 195# ??_${ARCH}_foo.${EPATCH_SUFFIX}
196# else
197# *.${EPATCH_SUFFIX}
198# @CODE
199# The leading ?? are typically numbers used to force consistent patch ordering.
200# The arch field is used to apply patches only for the host architecture with
201# the special value of "all" means apply for everyone. Note that using values
202# other than "all" is highly discouraged -- you should apply patches all the
203# time and let architecture details be detected at configure/compile time.
129# 204#
130# For example: 205# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
206# for patches to apply.
131# 207#
132# 01_all_misc-fix.patch.bz2 208# Refer to the other EPATCH_xxx variables for more customization of behavior.
133# 02_sparc_another-fix.patch.bz2
134#
135# This ensures that there are a set order, and you can have ARCH
136# specific patches.
137#
138# If you however give an argument to epatch(), it will treat it as a
139# single patch that need to be applied if its a file. If on the other
140# hand its a directory, it will set EPATCH_SOURCE to this.
141#
142# <azarah@gentoo.org> (10 Nov 2002)
143#
144epatch() { 209epatch() {
145 _epatch_draw_line() { 210 _epatch_draw_line() {
211 # create a line of same length as input string
146 [[ -z $1 ]] && set "$(printf "%65s" '')" 212 [[ -z $1 ]] && set "$(printf "%65s" '')"
147 echo "${1//?/=}" 213 echo "${1//?/=}"
148 } 214 }
149 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
150 local PIPE_CMD=""
151 local STDERR_TARGET="${T}/$$.out"
152 local PATCH_TARGET="${T}/$$.patch"
153 local PATCH_SUFFIX=""
154 local SINGLE_PATCH="no"
155 local x=""
156 215
157 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 216 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
158 217
159 if [ "$#" -gt 1 ] 218 # Let the rest of the code process one user arg at a time --
160 then 219 # each arg may expand into multiple patches, and each arg may
220 # need to start off with the default global EPATCH_xxx values
221 if [[ $# -gt 1 ]] ; then
161 local m="" 222 local m
162 for m in "$@" ; do 223 for m in "$@" ; do
163 epatch "${m}" 224 epatch "${m}"
164 done 225 done
165 return 0 226 return 0
166 fi 227 fi
167 228
168 if [ -n "$1" -a -f "$1" ] 229 local SINGLE_PATCH="no"
169 then 230 # no args means process ${EPATCH_SOURCE}
231 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
232
233 if [[ -f $1 ]] ; then
170 SINGLE_PATCH="yes" 234 SINGLE_PATCH="yes"
171 235 set -- "$1"
172 local EPATCH_SOURCE="$1" 236 # Use the suffix from the single patch (localize it); the code
237 # below will find the suffix for us
173 local EPATCH_SUFFIX="${1##*\.}" 238 local EPATCH_SUFFIX=$1
174 239
175 elif [ -n "$1" -a -d "$1" ] 240 elif [[ -d $1 ]] ; then
176 then 241 # Some people like to make dirs of patches w/out suffixes (vim)
177 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 242 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
178 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 243
244 else
245 # sanity check ... if it isn't a dir or file, wtf man ?
246 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
247 echo
248 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
249 eerror
250 eerror " ${EPATCH_SOURCE}"
251 eerror " ( ${EPATCH_SOURCE##*/} )"
252 echo
253 die "Cannot find \$EPATCH_SOURCE!"
254 fi
255
256 local PIPE_CMD
257 case ${EPATCH_SUFFIX##*\.} in
258 xz) PIPE_CMD="xz -dc" ;;
259 lzma) PIPE_CMD="lzma -dc" ;;
260 bz2) PIPE_CMD="bzip2 -dc" ;;
261 gz|Z|z) PIPE_CMD="gzip -dc" ;;
262 ZIP|zip) PIPE_CMD="unzip -p" ;;
263 *) ;;
264 esac
265
266 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
267
268 local x
269 for x in "$@" ; do
270 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
271 # didn't match anything, ignore continue on
272 [[ ! -f ${x} ]] && continue
273
274 local patchname=${x##*/}
275
276 # Apply single patches, or forced sets of patches, or
277 # patches with ARCH dependant names.
278 # ???_arch_foo.patch
279 # Else, skip this input altogether
280 local a=${patchname#*_} # strip the ???_
281 a=${a%%_*} # strip the _foo.patch
282 if ! [[ ${SINGLE_PATCH} == "yes" || \
283 ${EPATCH_FORCE} == "yes" || \
284 ${a} == all || \
285 ${a} == ${ARCH} ]]
179 then 286 then
180 local EPATCH_SOURCE="$1/*" 287 continue
288 fi
289
290 # Let people filter things dynamically
291 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
292 # let people use globs in the exclude
293 eshopts_push -o noglob
294
295 local ex
296 for ex in ${EPATCH_EXCLUDE} ; do
297 if [[ ${patchname} == ${ex} ]] ; then
298 eshopts_pop
299 continue 2
300 fi
301 done
302
303 eshopts_pop
304 fi
305
306 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
307 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
308 einfo "${EPATCH_SINGLE_MSG}"
309 else
310 einfo "Applying ${patchname} ..."
311 fi
181 else 312 else
182 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 313 einfo " ${patchname} ..."
183 fi 314 fi
184 else 315
185 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 316 # most of the time, there will only be one run per unique name,
186 then 317 # but if there are more, make sure we get unique log filenames
187 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 318 local STDERR_TARGET="${T}/${patchname}.out"
188 then 319 if [[ -e ${STDERR_TARGET} ]] ; then
189 EPATCH_SOURCE="$1" 320 STDERR_TARGET="${T}/${patchname}-$$.out"
321 fi
322
323 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
324
325 # Decompress the patch if need be
326 local count=0
327 local PATCH_TARGET
328 if [[ -n ${PIPE_CMD} ]] ; then
329 PATCH_TARGET="${T}/$$.patch"
330 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
331
332 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
333 echo
334 eerror "Could not extract patch!"
335 #die "Could not extract patch!"
336 count=5
337 break
190 fi 338 fi
339 else
340 PATCH_TARGET=${x}
341 fi
191 342
343 # Check for absolute paths in patches. If sandbox is disabled,
344 # people could (accidently) patch files in the root filesystem.
345 # Or trigger other unpleasantries #237667. So disallow -p0 on
346 # such patches.
347 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
348 if [[ -n ${abs_paths} ]] ; then
349 count=1
350 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
351 fi
352
353 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
354 while [[ ${count} -lt 5 ]] ; do
355 # Generate some useful debug info ...
356 (
357 _epatch_draw_line "***** ${patchname} *****"
192 echo 358 echo
193 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 359 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
360 echo
361 _epatch_draw_line "***** ${patchname} *****"
362 ) >> "${STDERR_TARGET}"
363
364 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
365 (
366 _epatch_draw_line "***** ${patchname} *****"
367 echo
368 echo "ACTUALLY APPLYING ${patchname} ..."
369 echo
370 _epatch_draw_line "***** ${patchname} *****"
371 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
372 ) >> "${STDERR_TARGET}"
373
374 if [ $? -ne 0 ] ; then
375 echo
376 eerror "A dry-run of patch command succeeded, but actually"
377 eerror "applying the patch failed!"
378 #die "Real world sux compared to the dreamworld!"
379 count=5
380 fi
381 break
382 fi
383
384 : $(( count++ ))
385 done
386
387 # if we had to decompress the patch, delete the temp one
388 if [[ -n ${PIPE_CMD} ]] ; then
389 rm -f "${PATCH_TARGET}"
390 fi
391
392 if [[ ${count} -ge 5 ]] ; then
393 echo
394 eerror "Failed Patch: ${patchname} !"
395 eerror " ( ${PATCH_TARGET} )"
194 eerror 396 eerror
195 eerror " ${EPATCH_SOURCE}" 397 eerror "Include in your bugreport the contents of:"
196 eerror " ( ${EPATCH_SOURCE##*/} )" 398 eerror
399 eerror " ${STDERR_TARGET}"
197 echo 400 echo
198 die "Cannot find \$EPATCH_SOURCE!"
199 fi
200
201 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
202 fi
203
204 case ${EPATCH_SUFFIX##*\.} in
205 bz2)
206 PIPE_CMD="bzip2 -dc"
207 PATCH_SUFFIX="bz2"
208 ;;
209 gz|Z|z)
210 PIPE_CMD="gzip -dc"
211 PATCH_SUFFIX="gz"
212 ;;
213 ZIP|zip)
214 PIPE_CMD="unzip -p"
215 PATCH_SUFFIX="zip"
216 ;;
217 *)
218 PIPE_CMD="cat"
219 PATCH_SUFFIX="patch"
220 ;;
221 esac
222
223 if [ "${SINGLE_PATCH}" = "no" ]
224 then
225 einfo "${EPATCH_MULTI_MSG}"
226 fi
227 for x in ${EPATCH_SOURCE}
228 do
229 # New ARCH dependant patch naming scheme ...
230 #
231 # ???_arch_foo.patch
232 #
233 if [ -f ${x} ] && \
234 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
235 [ "${EPATCH_FORCE}" = "yes" ])
236 then
237 local count=0
238 local popts="${EPATCH_OPTS}"
239 local patchname=${x##*/}
240
241 if [ -n "${EPATCH_EXCLUDE}" ]
242 then
243 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
244 then
245 continue
246 fi
247 fi
248
249 if [ "${SINGLE_PATCH}" = "yes" ]
250 then
251 if [ -n "${EPATCH_SINGLE_MSG}" ]
252 then
253 einfo "${EPATCH_SINGLE_MSG}"
254 else
255 einfo "Applying ${patchname} ..."
256 fi
257 else
258 einfo " ${patchname} ..."
259 fi
260
261 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
262 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
263
264 # Allow for prefix to differ ... im lazy, so shoot me :/
265 while [ "${count}" -lt 5 ]
266 do
267 # Generate some useful debug info ...
268 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
269 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
270
271 if [ "${PATCH_SUFFIX}" != "patch" ]
272 then
273 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
274 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
275 else
276 PATCH_TARGET="${x}"
277 fi
278
279 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
280 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
281
282 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
283 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
284
285 if [ "${PATCH_SUFFIX}" != "patch" ]
286 then
287 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
288 then
289 echo
290 eerror "Could not extract patch!"
291 #die "Could not extract patch!"
292 count=5
293 break
294 fi
295 fi
296
297 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
298 then
299 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
300 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
301 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
302 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
303 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
304
305 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
306 _epatch_assert
307
308 if [ "$?" -ne 0 ]
309 then
310 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
311 echo
312 eerror "A dry-run of patch command succeeded, but actually"
313 eerror "applying the patch failed!"
314 #die "Real world sux compared to the dreamworld!"
315 count=5
316 fi
317
318 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
319
320 break
321 fi
322
323 count=$((count + 1))
324 done
325
326 if [ "${PATCH_SUFFIX}" != "patch" ]
327 then
328 rm -f ${PATCH_TARGET}
329 fi
330
331 if [ "${count}" -eq 5 ]
332 then
333 echo
334 eerror "Failed Patch: ${patchname} !"
335 eerror " ( ${PATCH_TARGET} )"
336 eerror
337 eerror "Include in your bugreport the contents of:"
338 eerror
339 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
340 echo
341 die "Failed Patch: ${patchname}!" 401 die "Failed Patch: ${patchname}!"
342 fi 402 fi
343 403
344 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 404 # if everything worked, delete the patch log
345 405 rm -f "${STDERR_TARGET}"
346 eend 0 406 eend 0
347 fi
348 done 407 done
349 if [ "${SINGLE_PATCH}" = "no" ] 408
350 then 409 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
351 einfo "Done with patching" 410 : # everything worked
411}
412epatch_user() {
413 [[ $# -ne 0 ]] && die "epatch_user takes no options"
414
415 # don't clobber any EPATCH vars that the parent might want
416 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
417 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
418 EPATCH_SOURCE=${base}/${CTARGET}/${check}
419 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
420 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
421 if [[ -d ${EPATCH_SOURCE} ]] ; then
422 EPATCH_SOURCE=${EPATCH_SOURCE} \
423 EPATCH_SUFFIX="patch" \
424 EPATCH_FORCE="yes" \
425 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
426 epatch
427 break
352 fi 428 fi
429 done
353} 430}
354 431
432# @FUNCTION: emktemp
433# @USAGE: [temp dir]
434# @DESCRIPTION:
355# Cheap replacement for when debianutils (and thus mktemp) 435# Cheap replacement for when debianutils (and thus mktemp)
356# does not exist on the users system 436# does not exist on the users system.
357# vapier@gentoo.org
358#
359# Takes just 1 optional parameter (the directory to create tmpfile in)
360emktemp() { 437emktemp() {
361 local exe="touch" 438 local exe="touch"
362 [[ $1 == -d ]] && exe="mkdir" && shift 439 [[ $1 == -d ]] && exe="mkdir" && shift
363 local topdir=$1 440 local topdir=$1
364 441
366 [[ -z ${T} ]] \ 443 [[ -z ${T} ]] \
367 && topdir="/tmp" \ 444 && topdir="/tmp" \
368 || topdir=${T} 445 || topdir=${T}
369 fi 446 fi
370 447
371 if [[ -z $(type -p mktemp) ]] ; then 448 if ! type -P mktemp > /dev/null ; then
449 # system lacks `mktemp` so we have to fake it
372 local tmp=/ 450 local tmp=/
373 while [[ -e ${tmp} ]] ; do 451 while [[ -e ${tmp} ]] ; do
374 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 452 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
375 done 453 done
376 ${exe} "${tmp}" || ${exe} -p "${tmp}" 454 ${exe} "${tmp}" || ${exe} -p "${tmp}"
377 echo "${tmp}" 455 echo "${tmp}"
378 else 456 else
457 # the args here will give slightly wierd names on BSD,
458 # but should produce a usable file on all userlands
379 if [[ ${exe} == "touch" ]] ; then 459 if [[ ${exe} == "touch" ]] ; then
380 [[ ${USERLAND} == "GNU" ]] \
381 && mktemp -p "${topdir}" \
382 || TMPDIR="${topdir}" mktemp -t tmp 460 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
383 else 461 else
384 [[ ${USERLAND} == "GNU" ]] \
385 && mktemp -d "${topdir}" \
386 || TMPDIR="${topdir}" mktemp -dt tmp 462 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
387 fi
388 fi 463 fi
464 fi
389} 465}
390 466
467# @FUNCTION: egetent
468# @USAGE: <database> <key>
469# @MAINTAINER:
470# base-system@gentoo.org (Linux)
471# Joe Jezak <josejx@gmail.com> (OS X)
472# usata@gentoo.org (OS X)
473# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
474# @DESCRIPTION:
391# Small wrapper for getent (Linux), nidump (Mac OS X), 475# Small wrapper for getent (Linux),
476# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
392# and pw (FreeBSD) used in enewuser()/enewgroup() 477# and pw (FreeBSD) used in enewuser()/enewgroup()
393# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
394# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
395#
396# egetent(database, key)
397egetent() { 478egetent() {
398 case ${CHOST} in 479 case ${CHOST} in
399 *-darwin*) 480 *-darwin[678])
400 case "$2" in 481 case "$2" in
401 *[!0-9]*) # Non numeric 482 *[!0-9]*) # Non numeric
402 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 483 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
403 ;; 484 ;;
404 *) # Numeric 485 *) # Numeric
405 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 486 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
487 ;;
488 esac
489 ;;
490 *-darwin*)
491 local mytype=$1
492 [[ "passwd" == $mytype ]] && mytype="Users"
493 [[ "group" == $mytype ]] && mytype="Groups"
494 case "$2" in
495 *[!0-9]*) # Non numeric
496 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
497 ;;
498 *) # Numeric
499 local mykey="UniqueID"
500 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
501 dscl . -search /$mytype $mykey $2 2>/dev/null
406 ;; 502 ;;
407 esac 503 esac
408 ;; 504 ;;
409 *-freebsd*|*-dragonfly*) 505 *-freebsd*|*-dragonfly*)
410 local opts action="user" 506 local opts action="user"
425 getent "$1" "$2" 521 getent "$1" "$2"
426 ;; 522 ;;
427 esac 523 esac
428} 524}
429 525
430# Simplify/standardize adding users to the system 526# @FUNCTION: enewuser
431# vapier@gentoo.org 527# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
432# 528# @DESCRIPTION:
433# enewuser(username, uid, shell, homedir, groups, extra options) 529# Same as enewgroup, you are not required to understand how to properly add
434# 530# a user to the system. The only required parameter is the username.
435# Default values if you do not specify any: 531# Default uid is (pass -1 for this) next available, default shell is
436# username: REQUIRED ! 532# /bin/false, default homedir is /dev/null, there are no default groups,
437# uid: next available (see useradd(8)) 533# and default params sets the comment as 'added by portage for ${PN}'.
438# note: pass -1 to get default behavior
439# shell: /bin/false
440# homedir: /dev/null
441# groups: none
442# extra: comment of 'added by portage for ${PN}'
443enewuser() { 534enewuser() {
444 case ${EBUILD_PHASE} in 535 case ${EBUILD_PHASE} in
445 unpack|compile|test|install) 536 unpack|compile|test|install)
446 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 537 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
447 eerror "Package fails at QA and at life. Please file a bug." 538 eerror "Package fails at QA and at life. Please file a bug."
454 eerror "No username specified !" 545 eerror "No username specified !"
455 die "Cannot call enewuser without a username" 546 die "Cannot call enewuser without a username"
456 fi 547 fi
457 548
458 # lets see if the username already exists 549 # lets see if the username already exists
459 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then 550 if [[ -n $(egetent passwd "${euser}") ]] ; then
460 return 0 551 return 0
461 fi 552 fi
462 einfo "Adding user '${euser}' to your system ..." 553 einfo "Adding user '${euser}' to your system ..."
463 554
464 # options to pass to useradd 555 # options to pass to useradd
465 local opts= 556 local opts=
466 557
467 # handle uid 558 # handle uid
468 local euid=$1; shift 559 local euid=$1; shift
469 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then 560 if [[ -n ${euid} && ${euid} != -1 ]] ; then
470 if [[ ${euid} -gt 0 ]] ; then 561 if [[ ${euid} -gt 0 ]] ; then
471 if [[ ! -z $(egetent passwd ${euid}) ]] ; then 562 if [[ -n $(egetent passwd ${euid}) ]] ; then
472 euid="next" 563 euid="next"
473 fi 564 fi
474 else 565 else
475 eerror "Userid given but is not greater than 0 !" 566 eerror "Userid given but is not greater than 0 !"
476 die "${euid} is not a valid UID" 567 die "${euid} is not a valid UID"
477 fi 568 fi
478 else 569 else
479 euid="next" 570 euid="next"
480 fi 571 fi
481 if [[ ${euid} == "next" ]] ; then 572 if [[ ${euid} == "next" ]] ; then
482 for euid in $(seq 101 999) ; do 573 for ((euid = 101; euid <= 999; euid++)); do
483 [[ -z $(egetent passwd ${euid}) ]] && break 574 [[ -z $(egetent passwd ${euid}) ]] && break
484 done 575 done
485 fi 576 fi
486 opts="${opts} -u ${euid}" 577 opts="${opts} -u ${euid}"
487 einfo " - Userid: ${euid}" 578 einfo " - Userid: ${euid}"
501 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do 592 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
502 [[ -x ${ROOT}${shell} ]] && break 593 [[ -x ${ROOT}${shell} ]] && break
503 done 594 done
504 595
505 if [[ ${shell} == "/dev/null" ]] ; then 596 if [[ ${shell} == "/dev/null" ]] ; then
506 eerror "Unable to identify the shell to use" 597 eerror "Unable to identify the shell to use, proceeding with userland default."
507 die "Unable to identify the shell to use" 598 case ${USERLAND} in
599 GNU) shell="/bin/false" ;;
600 BSD) shell="/sbin/nologin" ;;
601 Darwin) shell="/usr/sbin/nologin" ;;
602 *) die "Unable to identify the default shell for userland ${USERLAND}"
603 esac
508 fi 604 fi
509 605
510 eshell=${shell} 606 eshell=${shell}
511 fi 607 fi
512 einfo " - Shell: ${eshell}" 608 einfo " - Shell: ${eshell}"
610 fi 706 fi
611 ;; 707 ;;
612 708
613 *) 709 *)
614 if [[ -z $@ ]] ; then 710 if [[ -z $@ ]] ; then
615 useradd ${opts} ${euser} \ 711 useradd ${opts} \
616 -c "added by portage for ${PN}" \ 712 -c "added by portage for ${PN}" \
713 ${euser} \
617 || die "enewuser failed" 714 || die "enewuser failed"
618 else 715 else
619 einfo " - Extra: $@" 716 einfo " - Extra: $@"
620 useradd ${opts} ${euser} "$@" \ 717 useradd ${opts} "$@" \
718 ${euser} \
621 || die "enewuser failed" 719 || die "enewuser failed"
622 fi 720 fi
623 ;; 721 ;;
624 esac 722 esac
625 723
631 fi 729 fi
632 730
633 export SANDBOX_ON=${oldsandbox} 731 export SANDBOX_ON=${oldsandbox}
634} 732}
635 733
636# Simplify/standardize adding groups to the system 734# @FUNCTION: enewgroup
637# vapier@gentoo.org 735# @USAGE: <group> [gid]
638# 736# @DESCRIPTION:
639# enewgroup(group, gid) 737# This function does not require you to understand how to properly add a
640# 738# group to the system. Just give it a group name to add and enewgroup will
641# Default values if you do not specify any: 739# do the rest. You may specify the gid for the group or allow the group to
642# groupname: REQUIRED ! 740# allocate the next available one.
643# gid: next available (see groupadd(8))
644# extra: none
645enewgroup() { 741enewgroup() {
646 case ${EBUILD_PHASE} in 742 case ${EBUILD_PHASE} in
647 unpack|compile|test|install) 743 unpack|compile|test|install)
648 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 744 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
649 eerror "Package fails at QA and at life. Please file a bug." 745 eerror "Package fails at QA and at life. Please file a bug."
657 eerror "No group specified !" 753 eerror "No group specified !"
658 die "Cannot call enewgroup without a group" 754 die "Cannot call enewgroup without a group"
659 fi 755 fi
660 756
661 # see if group already exists 757 # see if group already exists
662 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ] 758 if [[ -n $(egetent group "${egroup}") ]]; then
663 then
664 return 0 759 return 0
665 fi 760 fi
666 einfo "Adding group '${egroup}' to your system ..." 761 einfo "Adding group '${egroup}' to your system ..."
667 762
668 # options to pass to useradd 763 # options to pass to useradd
711 fi 806 fi
712 807
713 # If we need the next available 808 # If we need the next available
714 case ${egid} in 809 case ${egid} in
715 *[!0-9]*) # Non numeric 810 *[!0-9]*) # Non numeric
716 for egid in $(seq 101 999); do 811 for ((egid = 101; egid <= 999; egid++)); do
717 [ -z "`egetent group ${egid}`" ] && break 812 [[ -z $(egetent group ${egid}) ]] && break
718 done 813 done
719 esac 814 esac
720 dscl . create /groups/${egroup} gid ${egid} 815 dscl . create /groups/${egroup} gid ${egid}
721 dscl . create /groups/${egroup} passwd '*' 816 dscl . create /groups/${egroup} passwd '*'
722 ;; 817 ;;
723 818
724 *-freebsd*|*-dragonfly*) 819 *-freebsd*|*-dragonfly*)
725 case ${egid} in 820 case ${egid} in
726 *[!0-9]*) # Non numeric 821 *[!0-9]*) # Non numeric
727 for egid in $(seq 101 999); do 822 for ((egid = 101; egid <= 999; egid++)); do
728 [ -z "`egetent group ${egid}`" ] && break 823 [[ -z $(egetent group ${egid}) ]] && break
729 done 824 done
730 esac 825 esac
731 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 826 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
732 ;; 827 ;;
733 828
734 *-netbsd*) 829 *-netbsd*)
735 case ${egid} in 830 case ${egid} in
736 *[!0-9]*) # Non numeric 831 *[!0-9]*) # Non numeric
737 for egid in $(seq 101 999); do 832 for ((egid = 101; egid <= 999; egid++)); do
738 [ -z "`egetent group ${egid}`" ] && break 833 [[ -z $(egetent group ${egid}) ]] && break
739 done 834 done
740 esac 835 esac
741 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 836 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
742 ;; 837 ;;
743 838
746 ;; 841 ;;
747 esac 842 esac
748 export SANDBOX_ON="${oldsandbox}" 843 export SANDBOX_ON="${oldsandbox}"
749} 844}
750 845
751# Simple script to replace 'dos2unix' binaries 846# @FUNCTION: edos2unix
752# vapier@gentoo.org 847# @USAGE: <file> [more files ...]
753# 848# @DESCRIPTION:
754# edos2unix(file, <more files> ...) 849# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
850# to remove all of these text utilities from DEPEND variables because this
851# is a script based solution. Just give it a list of files to convert and
852# they will all be changed from the DOS CRLF format to the UNIX LF format.
755edos2unix() { 853edos2unix() {
756 for f in "$@" 854 echo "$@" | xargs sed -i 's/\r$//'
757 do
758 cp "${f}" ${T}/edos2unix
759 sed 's/\r$//' ${T}/edos2unix > "${f}"
760 done
761} 855}
762
763
764##############################################################
765# START: Handle .desktop files and menu entries #
766# maybe this should be separated into a new eclass some time #
767# lanius@gentoo.org #
768##############################################################
769 856
770# Make a desktop file ! 857# Make a desktop file !
771# Great for making those icons in kde/gnome startmenu ! 858# Great for making those icons in kde/gnome startmenu !
772# Amaze your friends ! Get the women ! Join today ! 859# Amaze your friends ! Get the women ! Join today !
773# 860#
774# make_desktop_entry(<command>, [name], [icon], [type], [path]) 861# make_desktop_entry(<command>, [name], [icon], [type], [path])
775# 862#
776# binary: what command does the app run with ? 863# binary: what command does the app run with ?
777# name: the name that will show up in the menu 864# name: the name that will show up in the menu
778# icon: give your little like a pretty little icon ... 865# icon: give your little like a pretty little icon ...
779# this can be relative (to /usr/share/pixmaps) or 866# this can be relative (to /usr/share/pixmaps) or
780# a full path to an icon 867# a full path to an icon
781# type: what kind of application is this ? for categories: 868# type: what kind of application is this ? for categories:
782# http://www.freedesktop.org/Standards/desktop-entry-spec 869# http://standards.freedesktop.org/menu-spec/latest/apa.html
783# path: if your app needs to startup in a specific dir 870# path: if your app needs to startup in a specific dir
784make_desktop_entry() { 871make_desktop_entry() {
785 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 872 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1
786 873
787 local exec=${1} 874 local exec=${1}
788 local name=${2:-${PN}} 875 local name=${2:-${PN}}
789 local icon=${3:-${PN}.png} 876 local icon=${3:-${PN}}
790 local type=${4} 877 local type=${4}
791 local path=${5} 878 local path=${5}
792 879
793 if [[ -z ${type} ]] ; then 880 if [[ -z ${type} ]] ; then
794 local catmaj=${CATEGORY%%-*} 881 local catmaj=${CATEGORY%%-*}
795 local catmin=${CATEGORY##*-} 882 local catmin=${CATEGORY##*-}
796 case ${catmaj} in 883 case ${catmaj} in
797 app) 884 app)
798 case ${catmin} in 885 case ${catmin} in
886 accessibility) type=Accessibility;;
799 admin) type=System;; 887 admin) type=System;;
888 antivirus) type=System;;
889 arch) type=Archiving;;
890 backup) type=Archiving;;
800 cdr) type=DiscBurning;; 891 cdr) type=DiscBurning;;
801 dicts) type=Dictionary;; 892 dicts) type=Dictionary;;
893 doc) type=Documentation;;
802 editors) type=TextEditor;; 894 editors) type=TextEditor;;
803 emacs) type=TextEditor;; 895 emacs) type=TextEditor;;
804 emulation) type=Emulator;; 896 emulation) type=Emulator;;
805 laptop) type=HardwareSettings;; 897 laptop) type=HardwareSettings;;
806 office) type=Office;; 898 office) type=Office;;
899 pda) type=PDA;;
807 vim) type=TextEditor;; 900 vim) type=TextEditor;;
808 xemacs) type=TextEditor;; 901 xemacs) type=TextEditor;;
809 *) type=;; 902 *) type=;;
810 esac 903 esac
811 ;; 904 ;;
812 905
813 dev) 906 dev)
814 type="Development" 907 type="Development"
815 ;; 908 ;;
816 909
817 games) 910 games)
818 case ${catmin} in 911 case ${catmin} in
819 action) type=ActionGame;; 912 action|fps) type=ActionGame;;
820 arcade) type=ArcadeGame;; 913 arcade) type=ArcadeGame;;
821 board) type=BoardGame;; 914 board) type=BoardGame;;
822 kids) type=KidsGame;;
823 emulation) type=Emulator;; 915 emulation) type=Emulator;;
916 kids) type=KidsGame;;
824 puzzle) type=LogicGame;; 917 puzzle) type=LogicGame;;
825 rpg) type=RolePlaying;;
826 roguelike) type=RolePlaying;; 918 roguelike) type=RolePlaying;;
919 rpg) type=RolePlaying;;
827 simulation) type=Simulation;; 920 simulation) type=Simulation;;
828 sports) type=SportsGame;; 921 sports) type=SportsGame;;
829 strategy) type=StrategyGame;; 922 strategy) type=StrategyGame;;
830 *) type=;; 923 *) type=;;
831 esac 924 esac
832 type="Game;${type}" 925 type="Game;${type}"
926 ;;
927
928 gnome)
929 type="Gnome;GTK"
930 ;;
931
932 kde)
933 type="KDE;Qt"
833 ;; 934 ;;
834 935
835 mail) 936 mail)
836 type="Network;Email" 937 type="Network;Email"
837 ;; 938 ;;
839 media) 940 media)
840 case ${catmin} in 941 case ${catmin} in
841 gfx) type=Graphics;; 942 gfx) type=Graphics;;
842 radio) type=Tuner;; 943 radio) type=Tuner;;
843 sound) type=Audio;; 944 sound) type=Audio;;
844 tv) type=TV;; 945 tv) type=TV;;
845 video) type=Video;; 946 video) type=Video;;
846 *) type=;; 947 *) type=;;
847 esac 948 esac
848 type="AudioVideo;${type}" 949 type="AudioVideo;${type}"
849 ;; 950 ;;
850 951
851 net) 952 net)
852 case ${catmin} in 953 case ${catmin} in
853 dialup) type=Dialup;; 954 dialup) type=Dialup;;
854 ftp) type=FileTransfer;; 955 ftp) type=FileTransfer;;
855 im) type=InstantMessaging;; 956 im) type=InstantMessaging;;
856 irc) type=IRCClient;; 957 irc) type=IRCClient;;
857 mail) type=Email;; 958 mail) type=Email;;
858 news) type=News;; 959 news) type=News;;
859 nntp) type=News;; 960 nntp) type=News;;
860 p2p) type=FileTransfer;; 961 p2p) type=FileTransfer;;
962 voip) type=Telephony;;
861 *) type=;; 963 *) type=;;
862 esac 964 esac
863 type="Network;${type}" 965 type="Network;${type}"
864 ;; 966 ;;
865 967
866 sci) 968 sci)
867 case ${catmin} in 969 case ${catmin} in
868 astro*) type=Astronomy;; 970 astro*) type=Astronomy;;
869 bio*) type=Biology;; 971 bio*) type=Biology;;
870 calc*) type=Calculator;; 972 calc*) type=Calculator;;
871 chem*) type=Chemistry;; 973 chem*) type=Chemistry;;
974 elec*) type=Electronics;;
872 geo*) type=Geology;; 975 geo*) type=Geology;;
873 math*) type=Math;; 976 math*) type=Math;;
977 physics) type=Physics;;
978 visual*) type=DataVisualization;;
874 *) type=;; 979 *) type=;;
875 esac 980 esac
876 type="Science;${type}" 981 type="Education;Science;${type}"
982 ;;
983
984 sys)
985 type="System"
877 ;; 986 ;;
878 987
879 www) 988 www)
880 case ${catmin} in 989 case ${catmin} in
881 client) type=WebBrowser;; 990 client) type=WebBrowser;;
882 *) type=;; 991 *) type=;;
883 esac 992 esac
884 type="Network" 993 type="Network;${type}"
885 ;; 994 ;;
886 995
887 *) 996 *)
888 type= 997 type=
889 ;; 998 ;;
892 if [ "${SLOT}" == "0" ] ; then 1001 if [ "${SLOT}" == "0" ] ; then
893 local desktop_name="${PN}" 1002 local desktop_name="${PN}"
894 else 1003 else
895 local desktop_name="${PN}-${SLOT}" 1004 local desktop_name="${PN}-${SLOT}"
896 fi 1005 fi
897 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 1006 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
898# local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1007 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
899 1008
1009 # Don't append another ";" when a valid category value is provided.
1010 type=${type%;}${type:+;}
1011
1012 eshopts_push -s extglob
1013 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1014 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1015 ewarn "allowed in .desktop files if the value is not an absolute path."
1016 icon=${icon%.@(xpm|png|svg)}
1017 fi
1018 eshopts_pop
1019
1020 cat <<-EOF > "${desktop}"
900echo "[Desktop Entry] 1021 [Desktop Entry]
901Encoding=UTF-8
902Version=0.9.2
903Name=${name} 1022 Name=${name}
904Type=Application 1023 Type=Application
905Comment=${DESCRIPTION} 1024 Comment=${DESCRIPTION}
906Exec=${exec} 1025 Exec=${exec}
907TryExec=${exec%% *} 1026 TryExec=${exec%% *}
908Path=${path}
909Icon=${icon} 1027 Icon=${icon}
910Categories=Application;${type};" > "${desktop}" 1028 Categories=${type}
1029 EOF
1030
1031 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}"
911 1032
912 ( 1033 (
913 # wrap the env here so that the 'insinto' call 1034 # wrap the env here so that the 'insinto' call
914 # doesn't corrupt the env of the caller 1035 # doesn't corrupt the env of the caller
915 insinto /usr/share/applications 1036 insinto /usr/share/applications
916 doins "${desktop}" 1037 doins "${desktop}"
917 ) 1038 )
918} 1039}
919 1040
920# Make a GDM/KDM Session file 1041# @FUNCTION: validate_desktop_entries
921# 1042# @USAGE: [directories]
922# make_desktop_entry(<title>, <command>) 1043# @MAINTAINER:
923# title: File to execute to start the Window Manager 1044# Carsten Lohrke <carlo@gentoo.org>
924# command: Name of the Window Manager 1045# @DESCRIPTION:
1046# Validate desktop entries using desktop-file-utils
1047validate_desktop_entries() {
1048 if [[ -x /usr/bin/desktop-file-validate ]] ; then
1049 einfo "Checking desktop entry validity"
1050 local directories=""
1051 for d in /usr/share/applications $@ ; do
1052 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
1053 done
1054 if [[ -n ${directories} ]] ; then
1055 for FILE in $(find ${directories} -name "*\.desktop" \
1056 -not -path '*.hidden*' | sort -u 2>/dev/null)
1057 do
1058 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1059 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1060 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
1061 done
1062 fi
1063 echo ""
1064 else
1065 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1066 fi
1067}
925 1068
1069# @FUNCTION: make_session_desktop
1070# @USAGE: <title> <command> [command args...]
1071# @DESCRIPTION:
1072# Make a GDM/KDM Session file. The title is the file to execute to start the
1073# Window Manager. The command is the name of the Window Manager.
1074#
1075# You can set the name of the file via the ${wm} variable.
926make_session_desktop() { 1076make_session_desktop() {
927 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1077 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
928 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1078 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
929 1079
930 local title=$1 1080 local title=$1
931 local command=$2 1081 local command=$2
932 local desktop=${T}/${wm}.desktop 1082 local desktop=${T}/${wm:-${PN}}.desktop
1083 shift 2
933 1084
1085 cat <<-EOF > "${desktop}"
934echo "[Desktop Entry] 1086 [Desktop Entry]
935Encoding=UTF-8
936Name=${title} 1087 Name=${title}
937Comment=This session logs you into ${title} 1088 Comment=This session logs you into ${title}
938Exec=${command} 1089 Exec=${command} $*
939TryExec=${command} 1090 TryExec=${command}
940Type=Application" > "${desktop}" 1091 Type=XSession
1092 EOF
941 1093
1094 (
1095 # wrap the env here so that the 'insinto' call
1096 # doesn't corrupt the env of the caller
942 insinto /usr/share/xsessions 1097 insinto /usr/share/xsessions
943 doins "${desktop}" 1098 doins "${desktop}"
1099 )
944} 1100}
945 1101
1102# @FUNCTION: domenu
1103# @USAGE: <menus>
1104# @DESCRIPTION:
1105# Install the list of .desktop menu files into the appropriate directory
1106# (/usr/share/applications).
946domenu() { 1107domenu() {
1108 (
1109 # wrap the env here so that the 'insinto' call
1110 # doesn't corrupt the env of the caller
947 local i j 1111 local i j ret=0
948 insinto /usr/share/applications 1112 insinto /usr/share/applications
949 for i in "$@" ; do 1113 for i in "$@" ; do
950 if [[ -f ${i} ]] ; then 1114 if [[ -f ${i} ]] ; then
951 doins "${i}" 1115 doins "${i}"
1116 ((ret+=$?))
952 elif [[ -d ${i} ]] ; then 1117 elif [[ -d ${i} ]] ; then
953 for j in "${i}"/*.desktop ; do 1118 for j in "${i}"/*.desktop ; do
954 doins "${j}" 1119 doins "${j}"
1120 ((ret+=$?))
955 done 1121 done
1122 else
1123 ((++ret))
956 fi 1124 fi
957 done 1125 done
1126 exit ${ret}
1127 )
958} 1128}
1129
1130# @FUNCTION: newmenu
1131# @USAGE: <menu> <newname>
1132# @DESCRIPTION:
1133# Like all other new* functions, install the specified menu as newname.
959newmenu() { 1134newmenu() {
1135 (
1136 # wrap the env here so that the 'insinto' call
1137 # doesn't corrupt the env of the caller
960 insinto /usr/share/applications 1138 insinto /usr/share/applications
961 newins "$1" "$2" 1139 newins "$@"
1140 )
962} 1141}
963 1142
1143# @FUNCTION: doicon
1144# @USAGE: <list of icons>
1145# @DESCRIPTION:
1146# Install the list of icons into the icon directory (/usr/share/pixmaps).
1147# This is useful in conjunction with creating desktop/menu files.
964doicon() { 1148doicon() {
1149 (
1150 # wrap the env here so that the 'insinto' call
1151 # doesn't corrupt the env of the caller
965 local i j 1152 local i j ret
966 insinto /usr/share/pixmaps 1153 insinto /usr/share/pixmaps
967 for i in "$@" ; do 1154 for i in "$@" ; do
968 if [[ -f ${i} ]] ; then 1155 if [[ -f ${i} ]] ; then
969 doins "${i}" 1156 doins "${i}"
1157 ((ret+=$?))
970 elif [[ -d ${i} ]] ; then 1158 elif [[ -d ${i} ]] ; then
971 for j in "${i}"/*.png ; do 1159 for j in "${i}"/*.png ; do
972 doins "${j}" 1160 doins "${j}"
1161 ((ret+=$?))
973 done 1162 done
1163 else
1164 ((++ret))
974 fi 1165 fi
975 done 1166 done
1167 exit ${ret}
1168 )
976} 1169}
1170
1171# @FUNCTION: newicon
1172# @USAGE: <icon> <newname>
1173# @DESCRIPTION:
1174# Like all other new* functions, install the specified icon as newname.
977newicon() { 1175newicon() {
1176 (
1177 # wrap the env here so that the 'insinto' call
1178 # doesn't corrupt the env of the caller
978 insinto /usr/share/pixmaps 1179 insinto /usr/share/pixmaps
979 newins "$1" "$2" 1180 newins "$@"
1181 )
980} 1182}
981
982##############################################################
983# END: Handle .desktop files and menu entries #
984##############################################################
985
986 1183
987# for internal use only (unpack_pdv and unpack_makeself) 1184# for internal use only (unpack_pdv and unpack_makeself)
988find_unpackable_file() { 1185find_unpackable_file() {
989 local src=$1 1186 local src=$1
990 if [[ -z ${src} ]] ; then 1187 if [[ -z ${src} ]] ; then
1000 fi 1197 fi
1001 [[ ! -e ${src} ]] && return 1 1198 [[ ! -e ${src} ]] && return 1
1002 echo "${src}" 1199 echo "${src}"
1003} 1200}
1004 1201
1202# @FUNCTION: unpack_pdv
1203# @USAGE: <file to unpack> <size of off_t>
1204# @DESCRIPTION:
1005# Unpack those pesky pdv generated files ... 1205# Unpack those pesky pdv generated files ...
1006# They're self-unpacking programs with the binary package stuffed in 1206# They're self-unpacking programs with the binary package stuffed in
1007# the middle of the archive. Valve seems to use it a lot ... too bad 1207# the middle of the archive. Valve seems to use it a lot ... too bad
1008# it seems to like to segfault a lot :(. So lets take it apart ourselves. 1208# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1009# 1209#
1010# Usage: unpack_pdv [file to unpack] [size of off_t]
1011# - you have to specify the off_t size ... i have no idea how to extract that 1210# You have to specify the off_t size ... I have no idea how to extract that
1012# information out of the binary executable myself. basically you pass in 1211# information out of the binary executable myself. Basically you pass in
1013# the size of the off_t type (in bytes) on the machine that built the pdv 1212# the size of the off_t type (in bytes) on the machine that built the pdv
1213# archive.
1214#
1014# archive. one way to determine this is by running the following commands: 1215# One way to determine this is by running the following commands:
1216#
1217# @CODE
1015# strings <pdv archive> | grep lseek 1218# strings <pdv archive> | grep lseek
1016# strace -elseek <pdv archive> 1219# strace -elseek <pdv archive>
1220# @CODE
1221#
1017# basically look for the first lseek command (we do the strings/grep because 1222# Basically look for the first lseek command (we do the strings/grep because
1018# sometimes the function call is _llseek or something) and steal the 2nd 1223# sometimes the function call is _llseek or something) and steal the 2nd
1019# parameter. here is an example: 1224# parameter. Here is an example:
1225#
1226# @CODE
1020# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 1227# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1021# lseek 1228# lseek
1022# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1229# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1023# lseek(3, -4, SEEK_END) = 2981250 1230# lseek(3, -4, SEEK_END) = 2981250
1231# @CODE
1232#
1024# thus we would pass in the value of '4' as the second parameter. 1233# Thus we would pass in the value of '4' as the second parameter.
1025unpack_pdv() { 1234unpack_pdv() {
1026 local src=$(find_unpackable_file $1) 1235 local src=$(find_unpackable_file "$1")
1027 local sizeoff_t=$2 1236 local sizeoff_t=$2
1028 1237
1029 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1238 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1030 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1239 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1031 1240
1032 local shrtsrc=$(basename "${src}") 1241 local shrtsrc=$(basename "${src}")
1033 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1242 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1034 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1243 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1035 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1244 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1036 1245
1037 # grab metadata for debug reasons 1246 # grab metadata for debug reasons
1038 local metafile="$(emktemp)" 1247 local metafile=$(emktemp)
1039 tail -c +$((${metaskip}+1)) ${src} > ${metafile} 1248 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1040 1249
1041 # rip out the final file name from the metadata 1250 # rip out the final file name from the metadata
1042 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`" 1251 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1043 datafile="`basename ${datafile}`" 1252 datafile=$(basename "${datafile}")
1044 1253
1045 # now lets uncompress/untar the file if need be 1254 # now lets uncompress/untar the file if need be
1046 local tmpfile="$(emktemp)" 1255 local tmpfile=$(emktemp)
1047 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile} 1256 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1048 1257
1049 local iscompressed="`file -b ${tmpfile}`" 1258 local iscompressed=$(file -b "${tmpfile}")
1050 if [ "${iscompressed:0:8}" == "compress" ] ; then 1259 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1051 iscompressed=1 1260 iscompressed=1
1052 mv ${tmpfile}{,.Z} 1261 mv ${tmpfile}{,.Z}
1053 gunzip ${tmpfile} 1262 gunzip ${tmpfile}
1054 else 1263 else
1055 iscompressed=0 1264 iscompressed=0
1056 fi 1265 fi
1057 local istar="`file -b ${tmpfile}`" 1266 local istar=$(file -b "${tmpfile}")
1058 if [ "${istar:0:9}" == "POSIX tar" ] ; then 1267 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1059 istar=1 1268 istar=1
1060 else 1269 else
1061 istar=0 1270 istar=0
1062 fi 1271 fi
1063 1272
1091 true 1300 true
1092 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1301 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1093 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1302 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1094} 1303}
1095 1304
1305# @FUNCTION: unpack_makeself
1306# @USAGE: [file to unpack] [offset] [tail|dd]
1307# @DESCRIPTION:
1096# Unpack those pesky makeself generated files ... 1308# Unpack those pesky makeself generated files ...
1097# They're shell scripts with the binary package tagged onto 1309# They're shell scripts with the binary package tagged onto
1098# the end of the archive. Loki utilized the format as does 1310# the end of the archive. Loki utilized the format as does
1099# many other game companies. 1311# many other game companies.
1100# 1312#
1101# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1313# If the file is not specified, then ${A} is used. If the
1102# - If the file is not specified then unpack will utilize ${A}.
1103# - If the offset is not specified then we will attempt to extract 1314# offset is not specified then we will attempt to extract
1104# the proper offset from the script itself. 1315# the proper offset from the script itself.
1105unpack_makeself() { 1316unpack_makeself() {
1106 local src_input=${1:-${A}} 1317 local src_input=${1:-${A}}
1107 local src=$(find_unpackable_file "${src_input}") 1318 local src=$(find_unpackable_file "${src_input}")
1108 local skip=$2 1319 local skip=$2
1109 local exe=$3 1320 local exe=$3
1155 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1366 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1156 *) die "makeself cant handle exe '${exe}'" 1367 *) die "makeself cant handle exe '${exe}'"
1157 esac 1368 esac
1158 1369
1159 # lets grab the first few bytes of the file to figure out what kind of archive it is 1370 # lets grab the first few bytes of the file to figure out what kind of archive it is
1160 local tmpfile="$(emktemp)" 1371 local tmpfile=$(emktemp)
1161 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1372 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1162 local filetype="$(file -b "${tmpfile}")" 1373 local filetype=$(file -b "${tmpfile}")
1163 case ${filetype} in 1374 case ${filetype} in
1164 *tar\ archive) 1375 *tar\ archive*)
1165 eval ${exe} | tar --no-same-owner -xf - 1376 eval ${exe} | tar --no-same-owner -xf -
1166 ;; 1377 ;;
1167 bzip2*) 1378 bzip2*)
1168 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf - 1379 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1169 ;; 1380 ;;
1179 ;; 1390 ;;
1180 esac 1391 esac
1181 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1392 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1182} 1393}
1183 1394
1395# @FUNCTION: check_license
1396# @USAGE: [license]
1397# @DESCRIPTION:
1184# Display a license for user to accept. 1398# Display a license for user to accept. If no license is
1185#
1186# Usage: check_license [license]
1187# - If the file is not specified then ${LICENSE} is used. 1399# specified, then ${LICENSE} is used.
1188check_license() { 1400check_license() {
1189 local lic=$1 1401 local lic=$1
1190 if [ -z "${lic}" ] ; then 1402 if [ -z "${lic}" ] ; then
1191 lic="${PORTDIR}/licenses/${LICENSE}" 1403 lic="${PORTDIR}/licenses/${LICENSE}"
1192 else 1404 else
1196 lic="${PWD}/${lic}" 1408 lic="${PWD}/${lic}"
1197 elif [ -e "${lic}" ] ; then 1409 elif [ -e "${lic}" ] ; then
1198 lic="${lic}" 1410 lic="${lic}"
1199 fi 1411 fi
1200 fi 1412 fi
1201 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1202 local l="`basename ${lic}`" 1413 local l="`basename ${lic}`"
1203 1414
1204 # here is where we check for the licenses the user already 1415 # here is where we check for the licenses the user already
1205 # accepted ... if we don't find a match, we make the user accept 1416 # accepted ... if we don't find a match, we make the user accept
1206 local shopts=$-
1207 local alic 1417 local alic
1208 set -o noglob #so that bash doesn't expand "*" 1418 eshopts_push -o noglob # so that bash doesn't expand "*"
1209 for alic in ${ACCEPT_LICENSE} ; do 1419 for alic in ${ACCEPT_LICENSE} ; do
1210 if [[ ${alic} == * || ${alic} == ${l} ]]; then 1420 if [[ ${alic} == ${l} ]]; then
1211 set +o noglob; set -${shopts} #reset old shell opts 1421 eshopts_pop
1212 return 0 1422 return 0
1213 fi 1423 fi
1214 done 1424 done
1215 set +o noglob; set -$shopts #reset old shell opts 1425 eshopts_pop
1426 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1216 1427
1217 local licmsg="$(emktemp)" 1428 local licmsg=$(emktemp)
1218 cat << EOF > ${licmsg} 1429 cat <<-EOF > ${licmsg}
1219********************************************************** 1430 **********************************************************
1220The following license outlines the terms of use of this 1431 The following license outlines the terms of use of this
1221package. You MUST accept this license for installation to 1432 package. You MUST accept this license for installation to
1222continue. When you are done viewing, hit 'q'. If you 1433 continue. When you are done viewing, hit 'q'. If you
1223CTRL+C out of this, the install will not run! 1434 CTRL+C out of this, the install will not run!
1224********************************************************** 1435 **********************************************************
1225 1436
1226EOF 1437 EOF
1227 cat ${lic} >> ${licmsg} 1438 cat ${lic} >> ${licmsg}
1228 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1439 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1229 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1440 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1230 read alic 1441 read alic
1231 case ${alic} in 1442 case ${alic} in
1238 die "Failed to accept license" 1449 die "Failed to accept license"
1239 ;; 1450 ;;
1240 esac 1451 esac
1241} 1452}
1242 1453
1454# @FUNCTION: cdrom_get_cds
1455# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1456# @DESCRIPTION:
1243# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1457# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1244# the whole 'non-interactive' policy, but damnit I want CD support ! 1458# the whole 'non-interactive' policy, but damnit I want CD support !
1245# 1459#
1246# with these cdrom functions we handle all the user interaction and 1460# With these cdrom functions we handle all the user interaction and
1247# standardize everything. all you have to do is call cdrom_get_cds() 1461# standardize everything. All you have to do is call cdrom_get_cds()
1248# and when the function returns, you can assume that the cd has been 1462# and when the function returns, you can assume that the cd has been
1249# found at CDROM_ROOT. 1463# found at CDROM_ROOT.
1250# 1464#
1465# The function will attempt to locate a cd based upon a file that is on
1466# the cd. The more files you give this function, the more cds
1467# the cdrom functions will handle.
1468#
1251# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1469# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1252# etc... if you want to give the cds better names, then just export 1470# etc... If you want to give the cds better names, then just export
1253# the appropriate CDROM_NAME variable before calling cdrom_get_cds(). 1471# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1254# - CDROM_NAME="fooie cd" - for when you only want 1 cd 1472# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1255# - CDROM_NAME_1="install cd" - for when you want more than 1 cd 1473# also use the CDROM_NAME_SET bash array.
1256# CDROM_NAME_2="data cd"
1257# - CDROM_NAME_SET=( "install cd" "data cd" ) - short hand for CDROM_NAME_#
1258# 1474#
1259# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1475# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1260#
1261# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1262# - this will attempt to locate a cd based upon a file that is on
1263# the cd ... the more files you give this function, the more cds
1264# the cdrom functions will handle
1265cdrom_get_cds() { 1476cdrom_get_cds() {
1266 # first we figure out how many cds we're dealing with by 1477 # first we figure out how many cds we're dealing with by
1267 # the # of files they gave us 1478 # the # of files they gave us
1268 local cdcnt=0 1479 local cdcnt=0
1269 local f= 1480 local f=
1355 export CDROM_SET="" 1566 export CDROM_SET=""
1356 export CDROM_CURRENT_CD=0 1567 export CDROM_CURRENT_CD=0
1357 cdrom_load_next_cd 1568 cdrom_load_next_cd
1358} 1569}
1359 1570
1360# this is only used when you need access to more than one cd. 1571# @FUNCTION: cdrom_load_next_cd
1361# when you have finished using the first cd, just call this function. 1572# @DESCRIPTION:
1362# when it returns, CDROM_ROOT will be pointing to the second cd. 1573# Some packages are so big they come on multiple CDs. When you're done reading
1363# remember, you can only go forward in the cd chain, you can't go back. 1574# files off a CD and want access to the next one, just call this function.
1575# Again, all the messy details of user interaction are taken care of for you.
1576# Once this returns, just read the variable CDROM_ROOT for the location of the
1577# mounted CD. Note that you can only go forward in the CD list, so make sure
1578# you only call this function when you're done using the current CD.
1364cdrom_load_next_cd() { 1579cdrom_load_next_cd() {
1365 local var 1580 local var
1366 ((++CDROM_CURRENT_CD)) 1581 ((++CDROM_CURRENT_CD))
1367 1582
1368 unset CDROM_ROOT 1583 unset CDROM_ROOT
1385# displayed and we'll hang out here until: 1600# displayed and we'll hang out here until:
1386# (1) the file is found on a mounted cdrom 1601# (1) the file is found on a mounted cdrom
1387# (2) the user hits CTRL+C 1602# (2) the user hits CTRL+C
1388_cdrom_locate_file_on_cd() { 1603_cdrom_locate_file_on_cd() {
1389 local mline="" 1604 local mline=""
1390 local showedmsg=0 1605 local showedmsg=0 showjolietmsg=0
1391 1606
1392 while [[ -z ${CDROM_ROOT} ]] ; do 1607 while [[ -z ${CDROM_ROOT} ]] ; do
1393 local i=0 1608 local i=0
1394 local -a cdset=(${*//:/ }) 1609 local -a cdset=(${*//:/ })
1395 if [[ -n ${CDROM_SET} ]] ; then 1610 if [[ -n ${CDROM_SET} ]] ; then
1398 1613
1399 while [[ -n ${cdset[${i}]} ]] ; do 1614 while [[ -n ${cdset[${i}]} ]] ; do
1400 local dir=$(dirname ${cdset[${i}]}) 1615 local dir=$(dirname ${cdset[${i}]})
1401 local file=$(basename ${cdset[${i}]}) 1616 local file=$(basename ${cdset[${i}]})
1402 1617
1403 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1618 local point= node= fs= foo=
1619 while read point node fs foo ; do
1620 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1621 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1622 && continue
1623 point=${point//\040/ }
1404 [[ -d ${mline}/${dir} ]] || continue 1624 [[ ! -d ${point}/${dir} ]] && continue
1405 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1625 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1406 export CDROM_ROOT=${mline} 1626 export CDROM_ROOT=${point}
1407 export CDROM_SET=${i} 1627 export CDROM_SET=${i}
1408 export CDROM_MATCH=${cdset[${i}]} 1628 export CDROM_MATCH=${cdset[${i}]}
1409 return 1629 return
1410 fi 1630 done <<< "$(get_mounts)"
1411 done
1412 1631
1413 ((++i)) 1632 ((++i))
1414 done 1633 done
1415 1634
1416 echo 1635 echo
1432 showedmsg=1 1651 showedmsg=1
1433 fi 1652 fi
1434 einfo "Press return to scan for the cd again" 1653 einfo "Press return to scan for the cd again"
1435 einfo "or hit CTRL+C to abort the emerge." 1654 einfo "or hit CTRL+C to abort the emerge."
1436 echo 1655 echo
1656 if [[ ${showjolietmsg} -eq 0 ]] ; then
1657 showjolietmsg=1
1658 else
1437 einfo "If you are having trouble with the detection" 1659 ewarn "If you are having trouble with the detection"
1438 einfo "of your CD, it is possible that you do not have" 1660 ewarn "of your CD, it is possible that you do not have"
1439 einfo "Joliet support enabled in your kernel. Please" 1661 ewarn "Joliet support enabled in your kernel. Please"
1440 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1662 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1663 ebeep 5
1664 fi
1441 read || die "something is screwed with your system" 1665 read || die "something is screwed with your system"
1442 done 1666 done
1443} 1667}
1444 1668
1669# @FUNCTION: strip-linguas
1670# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1671# @DESCRIPTION:
1445# Make sure that LINGUAS only contains languages that 1672# Make sure that LINGUAS only contains languages that
1446# a package can support 1673# a package can support. The first form allows you to
1447# 1674# specify a list of LINGUAS. The -i builds a list of po
1448# usage: strip-linguas <allow LINGUAS> 1675# files found in all the directories and uses the
1449# strip-linguas -i <directories of .po files> 1676# intersection of the lists. The -u builds a list of po
1450# strip-linguas -u <directories of .po files> 1677# files found in all the directories and uses the union
1451# 1678# of the lists.
1452# The first form allows you to specify a list of LINGUAS.
1453# The -i builds a list of po files found in all the
1454# directories and uses the intersection of the lists.
1455# The -u builds a list of po files found in all the
1456# directories and uses the union of the lists.
1457strip-linguas() { 1679strip-linguas() {
1458 local ls newls nols 1680 local ls newls nols
1459 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1681 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1460 local op=$1; shift 1682 local op=$1; shift
1461 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1683 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1462 local d f 1684 local d f
1463 for d in "$@" ; do 1685 for d in "$@" ; do
1464 if [[ ${op} == "-u" ]] ; then 1686 if [[ ${op} == "-u" ]] ; then
1465 newls=${ls} 1687 newls=${ls}
1466 else 1688 else
1467 newls="" 1689 newls=""
1468 fi 1690 fi
1469 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1691 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1470 if [[ ${op} == "-i" ]] ; then 1692 if [[ ${op} == "-i" ]] ; then
1471 hasq ${f} ${ls} && newls="${newls} ${f}" 1693 hasq ${f} ${ls} && newls="${newls} ${f}"
1472 else 1694 else
1473 hasq ${f} ${ls} || newls="${newls} ${f}" 1695 hasq ${f} ${ls} || newls="${newls} ${f}"
1474 fi 1696 fi
1487 else 1709 else
1488 nols="${nols} ${f}" 1710 nols="${nols} ${f}"
1489 fi 1711 fi
1490 done 1712 done
1491 [[ -n ${nols} ]] \ 1713 [[ -n ${nols} ]] \
1492 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1714 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1493 export LINGUAS=${newls:1} 1715 export LINGUAS=${newls:1}
1494} 1716}
1495 1717
1496# moved from kernel.eclass since they are generally useful outside of 1718# @FUNCTION: preserve_old_lib
1497# kernel.eclass -iggy (20041002) 1719# @USAGE: <libs to preserve> [more libs]
1498 1720# @DESCRIPTION:
1499# the following functions are useful in kernel module ebuilds, etc.
1500# for an example see ivtv or drbd ebuilds
1501
1502# set's ARCH to match what the kernel expects
1503set_arch_to_kernel() {
1504 i=10
1505 while ((i--)) ; do
1506 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1507 done
1508 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1509 case ${ARCH} in
1510 x86) export ARCH="i386";;
1511 amd64) export ARCH="x86_64";;
1512 hppa) export ARCH="parisc";;
1513 mips) export ARCH="mips";;
1514 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1515 *) export ARCH="${ARCH}";;
1516 esac
1517}
1518
1519# set's ARCH back to what portage expects
1520set_arch_to_portage() {
1521 i=10
1522 while ((i--)) ; do
1523 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1524 done
1525 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1526}
1527
1528# Jeremy Huddleston <eradicator@gentoo.org>:
1529# preserve_old_lib /path/to/libblah.so.0
1530# preserve_old_lib_notify /path/to/libblah.so.0
1531#
1532# These functions are useful when a lib in your package changes --library. Such 1721# These functions are useful when a lib in your package changes ABI SONAME.
1533# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1722# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1534# would break packages that link against it. Most people get around this 1723# would break packages that link against it. Most people get around this
1535# by using the portage SLOT mechanism, but that is not always a relevant 1724# by using the portage SLOT mechanism, but that is not always a relevant
1536# solution, so instead you can add the following to your ebuilds: 1725# solution, so instead you can call this from pkg_preinst. See also the
1537# 1726# preserve_old_lib_notify function.
1538# src_install() {
1539# ...
1540# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1541# ...
1542# }
1543#
1544# pkg_postinst() {
1545# ...
1546# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1547# ...
1548# }
1549
1550preserve_old_lib() { 1727preserve_old_lib() {
1551 LIB=$1 1728 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1729 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1730 die "Invalid preserve_old_lib() usage"
1731 fi
1732 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1552 1733
1553 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1734 # let portage worry about it
1554 SONAME=`basename ${LIB}` 1735 has preserve-libs ${FEATURES} && return 0
1555 DIRNAME=`dirname ${LIB}`
1556 1736
1557 dodir ${DIRNAME} 1737 local lib dir
1558 cp ${ROOT}${LIB} ${D}${DIRNAME} 1738 for lib in "$@" ; do
1739 [[ -e ${ROOT}/${lib} ]] || continue
1740 dir=${lib%/*}
1741 dodir ${dir} || die "dodir ${dir} failed"
1742 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1559 touch ${D}${LIB} 1743 touch "${D}"/${lib}
1560 fi 1744 done
1561} 1745}
1562 1746
1747# @FUNCTION: preserve_old_lib_notify
1748# @USAGE: <libs to notify> [more libs]
1749# @DESCRIPTION:
1750# Spit helpful messages about the libraries preserved by preserve_old_lib.
1563preserve_old_lib_notify() { 1751preserve_old_lib_notify() {
1564 LIB=$1 1752 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1753 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1754 die "Invalid preserve_old_lib_notify() usage"
1755 fi
1565 1756
1566 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1757 # let portage worry about it
1567 SONAME=`basename ${LIB}` 1758 has preserve-libs ${FEATURES} && return 0
1568 1759
1760 local lib notice=0
1761 for lib in "$@" ; do
1762 [[ -e ${ROOT}/${lib} ]] || continue
1763 if [[ ${notice} -eq 0 ]] ; then
1764 notice=1
1569 ewarn "An old version of an installed library was detected on your system." 1765 ewarn "Old versions of installed libraries were detected on your system."
1570 ewarn "In order to avoid breaking packages that link against it, this older version" 1766 ewarn "In order to avoid breaking packages that depend on these old libs,"
1571 ewarn "is not being removed. In order to make full use of this newer version," 1767 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1572 ewarn "you will need to execute the following command:" 1768 ewarn "in order to remove these old dependencies. If you do not have this"
1769 ewarn "helper program, simply emerge the 'gentoolkit' package."
1770 ewarn
1771 fi
1573 ewarn " revdep-rebuild --library ${SONAME}" 1772 ewarn " # revdep-rebuild --library ${lib##*/}"
1773 done
1774 if [[ ${notice} -eq 1 ]] ; then
1574 ewarn 1775 ewarn
1575 ewarn "After doing that, you can safely remove ${LIB}" 1776 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1576 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1777 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1778 for lib in "$@" ; do
1779 ewarn " # rm '${lib}'"
1780 done
1577 fi 1781 fi
1578} 1782}
1579 1783
1580# Hack for people to figure out if a package was built with 1784# @FUNCTION: built_with_use
1581# certain USE flags 1785# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1786# @DESCRIPTION:
1582# 1787#
1583# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1788# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1584# ex: built_with_use xchat gtk2
1585# 1789#
1586# Flags: -a all USE flags should be utilized 1790# A temporary hack until portage properly supports DEPENDing on USE
1587# -o at least one USE flag should be utilized 1791# flags being enabled in packages. This will check to see if the specified
1588# Note: the default flag is '-a' 1792# DEPEND atom was built with the specified list of USE flags. The
1793# --missing option controls the behavior if called on a package that does
1794# not actually support the defined USE flags (aka listed in IUSE).
1795# The default is to abort (call die). The -a and -o flags control
1796# the requirements of the USE flags. They correspond to "and" and "or"
1797# logic. So the -a flag means all listed USE flags must be enabled
1798# while the -o flag means at least one of the listed IUSE flags must be
1799# enabled. The --hidden option is really for internal use only as it
1800# means the USE flag we're checking is hidden expanded, so it won't be found
1801# in IUSE like normal USE flags.
1802#
1803# Remember that this function isn't terribly intelligent so order of optional
1804# flags matter.
1589built_with_use() { 1805built_with_use() {
1806 local hidden="no"
1807 if [[ $1 == "--hidden" ]] ; then
1808 hidden="yes"
1809 shift
1810 fi
1811
1812 local missing_action="die"
1813 if [[ $1 == "--missing" ]] ; then
1814 missing_action=$2
1815 shift ; shift
1816 case ${missing_action} in
1817 true|false|die) ;;
1818 *) die "unknown action '${missing_action}'";;
1819 esac
1820 fi
1821
1590 local opt=$1 1822 local opt=$1
1591 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1823 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1592 1824
1593 local PKG=$(best_version $1) 1825 local PKG=$(best_version $1)
1594 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package" 1826 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1595 shift 1827 shift
1596 1828
1597 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1829 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1598 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE 1830 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1599 1831
1600 # if the USE file doesnt exist, assume the $PKG is either 1832 # if the IUSE file doesn't exist, the read will error out, we need to handle
1601 # injected or package.provided 1833 # this gracefully
1834 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1835 case ${missing_action} in
1836 true) return 0;;
1837 false) return 1;;
1602 [[ ! -e ${USEFILE} ]] && die "Unable to determine what USE flags $PKG was built with" 1838 die) die "Unable to determine what USE flags $PKG was built with";;
1839 esac
1840 fi
1603 1841
1842 if [[ ${hidden} == "no" ]] ; then
1604 local IUSE_BUILT=$(<${IUSEFILE}) 1843 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1605 # Don't check USE_EXPAND #147237 1844 # Don't check USE_EXPAND #147237
1606 local expand 1845 local expand
1607 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1846 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1608 if [[ $1 == ${expand}_* ]] ; then 1847 if [[ $1 == ${expand}_* ]] ; then
1609 expand="" 1848 expand=""
1610 break 1849 break
1611 fi 1850 fi
1612 done 1851 done
1613 if [[ -n ${expand} ]] ; then 1852 if [[ -n ${expand} ]] ; then
1853 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1854 case ${missing_action} in
1855 true) return 0;;
1856 false) return 1;;
1614 has $1 ${IUSE_BUILT} || die "$PKG does not actually support the $1 USE flag!" 1857 die) die "$PKG does not actually support the $1 USE flag!";;
1858 esac
1859 fi
1860 fi
1615 fi 1861 fi
1616 1862
1617 local USE_BUILT=$(<${USEFILE}) 1863 local USE_BUILT=$(<${USEFILE})
1618 while [[ $# -gt 0 ]] ; do 1864 while [[ $# -gt 0 ]] ; do
1619 if [[ ${opt} = "-o" ]] ; then 1865 if [[ ${opt} = "-o" ]] ; then
1624 shift 1870 shift
1625 done 1871 done
1626 [[ ${opt} = "-a" ]] 1872 [[ ${opt} = "-a" ]]
1627} 1873}
1628 1874
1875# @FUNCTION: epunt_cxx
1876# @USAGE: [dir to scan]
1877# @DESCRIPTION:
1629# Many configure scripts wrongly bail when a C++ compiler 1878# Many configure scripts wrongly bail when a C++ compiler could not be
1630# could not be detected. #73450 1879# detected. If dir is not specified, then it defaults to ${S}.
1880#
1881# http://bugs.gentoo.org/73450
1631epunt_cxx() { 1882epunt_cxx() {
1632 local dir=$1 1883 local dir=$1
1633 [[ -z ${dir} ]] && dir=${S} 1884 [[ -z ${dir} ]] && dir=${S}
1634 ebegin "Removing useless C++ checks" 1885 ebegin "Removing useless C++ checks"
1635 local f 1886 local f
1636 for f in $(find ${dir} -name configure) ; do 1887 find "${dir}" -name configure | while read f ; do
1637 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1888 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1638 done 1889 done
1639 eend 0 1890 eend 0
1640} 1891}
1641 1892
1642# dopamd <file> [more files] 1893# @FUNCTION: make_wrapper
1643# 1894# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1644# Install pam auth config file in /etc/pam.d 1895# @DESCRIPTION:
1645dopamd() { 1896# Create a shell wrapper script named wrapper in installpath
1646 [[ -z $1 ]] && die "dopamd requires at least one argument" 1897# (defaults to the bindir) to execute target (default of wrapper) by
1647 1898# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1648 use pam || return 0 1899# libpaths followed by optionally changing directory to chdir.
1649
1650 INSDESTTREE=/etc/pam.d \
1651 doins "$@" || die "failed to install $@"
1652}
1653# newpamd <old name> <new name>
1654#
1655# Install pam file <old name> as <new name> in /etc/pam.d
1656newpamd() {
1657 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1658
1659 use pam || return 0
1660
1661 INSDESTTREE=/etc/pam.d \
1662 newins "$1" "$2" || die "failed to install $1 as $2"
1663}
1664
1665# make a wrapper script ...
1666# NOTE: this was originally games_make_wrapper, but I noticed other places where
1667# this could be used, so I have moved it here and made it not games-specific
1668# -- wolf31o2
1669# $1 == wrapper name
1670# $2 == binary to run
1671# $3 == directory to chdir before running binary
1672# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1673# $5 == path for wrapper
1674make_wrapper() { 1900make_wrapper() {
1675 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1901 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1676 local tmpwrapper=$(emktemp) 1902 local tmpwrapper=$(emktemp)
1677 # We don't want to quote ${bin} so that people can pass complex 1903 # We don't want to quote ${bin} so that people can pass complex
1678 # things as $bin ... "./someprog --args" 1904 # things as $bin ... "./someprog --args"
1688fi 1914fi
1689exec ${bin} "\$@" 1915exec ${bin} "\$@"
1690EOF 1916EOF
1691 chmod go+rx "${tmpwrapper}" 1917 chmod go+rx "${tmpwrapper}"
1692 if [[ -n ${path} ]] ; then 1918 if [[ -n ${path} ]] ; then
1919 (
1693 exeinto "${path}" 1920 exeinto "${path}"
1694 newexe "${tmpwrapper}" "${wrapper}" 1921 newexe "${tmpwrapper}" "${wrapper}"
1922 ) || die
1695 else 1923 else
1696 newbin "${tmpwrapper}" "${wrapper}" 1924 newbin "${tmpwrapper}" "${wrapper}" || die
1925 fi
1926}
1927
1928# @FUNCTION: prepalldocs
1929# @USAGE:
1930# @DESCRIPTION:
1931# Compress files in /usr/share/doc which are not already
1932# compressed, excluding /usr/share/doc/${PF}/html.
1933# Uses the ecompressdir to do the compression.
1934# 2009-02-18 by betelgeuse:
1935# Commented because ecompressdir is even more internal to
1936# Portage than prepalldocs (it's not even mentioned in man 5
1937# ebuild). Please submit a better version for review to gentoo-dev
1938# if you want prepalldocs here.
1939#prepalldocs() {
1940# if [[ -n $1 ]] ; then
1941# ewarn "prepalldocs: invalid usage; takes no arguments"
1697 fi 1942# fi
1698} 1943
1944# cd "${D}"
1945# [[ -d usr/share/doc ]] || return 0
1946
1947# find usr/share/doc -exec gzip {} +
1948# ecompressdir --ignore /usr/share/doc/${PF}/html
1949# ecompressdir --queue /usr/share/doc
1950#}

Legend:
Removed from v.1.252  
changed lines
  Added in v.1.337

  ViewVC Help
Powered by ViewVC 1.1.20